﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Globalization;
using System.Threading;

namespace Sample_GridEditing
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow ()
        {
            InitializeComponent();
        }

        private System.Data.Objects.ObjectQuery<ExpenseLedgerPlan> GetExpenseLedgerPlansQuery (InsurableRiskEntities1 insurableRiskEntities)
        {
            // Auto generated code

            System.Data.Objects.ObjectQuery<Sample_GridEditing.ExpenseLedgerPlan> expenseLedgerPlansQuery = insurableRiskEntities.ExpenseLedgerPlans;
            // Returns an ObjectQuery.
            return (System.Data.Objects.ObjectQuery<ExpenseLedgerPlan>) expenseLedgerPlansQuery.Where(p => p.PlanYear == 2013);
        }

        private void Window_Loaded (object sender, RoutedEventArgs e)
        {

            Sample_GridEditing.InsurableRiskEntities1 insurableRiskEntities = new Sample_GridEditing.InsurableRiskEntities1();
            // Load data into ExpenseLedgerPlans. You can modify this code as needed.
            System.Windows.Data.CollectionViewSource expenseLedgerPlansViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("expenseLedgerPlansViewSource")));
            System.Data.Objects.ObjectQuery<Sample_GridEditing.ExpenseLedgerPlan> expenseLedgerPlansQuery = this.GetExpenseLedgerPlansQuery(insurableRiskEntities);
            expenseLedgerPlansViewSource.Source = expenseLedgerPlansQuery.Execute(System.Data.Objects.MergeOption.AppendOnly);
        }

        private void ExpenseLedgerPlanGrid_FieldLayoutInitialized (object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            foreach (var fieldLayout in ExpenseLedgerPlanGrid.FieldLayouts)
            {
                if (fieldLayout.Description == "ExpenseLedgerPlan")
                {
                    foreach (var field in fieldLayout.Fields)
                    {
                        if (!(field.Name == "ExpenseLedgerPlanKey"))
                            field.Settings.AllowEdit = true;
                        if (field.Name.Contains("Meta") || field.Name.Contains("Audit") || field.Name.Contains("IsDirty") || field.Name.Contains("Error"))
                        {
                            field.Visibility = Visibility.Collapsed;
                        }
                        switch (field.Name)
                        {
                            case "ExpenseLedgerPlanKey": field.Label = "Expense Ledger Plan #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "PlanYear": field.Label = "Plan Year";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "PlanLengthInYrs": field.Label = "Plan Length";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "NumberOfLobAllocations": field.Label = "No Of Allocations";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                               
                                break;
                            case "SubAllocationLabel1": field.Label = "Sub Allocation #1";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocationLabel2": field.Label = "Sub Allocation #2";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocationLabel3": field.Label = "Sub Allocation #3";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocationLabel4": field.Label = "Sub Allocation #4";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocationLabel5": field.Label = "Sub Allocation #5";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocationLabel6": field.Label = "Sub Allocation #6";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocationLabel7": field.Label = "Sub Allocation #7";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocationLabel8": field.Label = "Sub Allocation #8";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocationLabel9": field.Label = "Sub Allocation #9";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            default: break;
                        }
                    }
                }
                else if (fieldLayout.Description == "ExpenseLedgerItem")
                {
                    foreach (var field in fieldLayout.Fields)
                    {
                        if (!(field.Name == "ExpenseLegderItemKey"))
                            field.Settings.AllowEdit = true;
                        if (field.Name.Contains("Meta") || field.Name.Contains("Audit") || field.Name.Contains("IsDirty") || field.Name.Contains("Error") || field.Name == "ExpenseLedgerPlan" || field.Name == "LobAllocation")
                        {
                            field.Visibility = Visibility.Collapsed;
                        }
                        switch (field.Name)
                        {
                            case "ExpenseLedgerItemKey": field.Label = "Expense Ledger Item #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ExpenseLedgerPlanKey": field.Label = "Expense Ledger Plan #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ItemCode": field.Label = "Item Code";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ScheduleTitleKey": field.Label = "Schedule Title";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "LobAllocationKey": field.Label = "Lob Allocation";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ExpenseItemFM": field.Label = "Expense Item";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "EffectiveDate": field.Label = "Effective Date";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ExpirationDate": field.Label = "Expiration Date";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "LedgerExpenseAsOfDate": field.Label = "Ledger Expense - Date";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "Premium": field.Label = "Premium";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "Comment": field.Label = "Comment";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "LinkCode": field.Label = "Link Code";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            default: break;
                        }
                    }
                }
                else if (fieldLayout.Description == "LobAllocation")
                {
                    foreach (var field in fieldLayout.Fields)
                    {
                        if (!(field.Name == "LobAllocationKey"))
                            field.Settings.AllowEdit = true;
                        if (field.Name.Contains("Meta") || field.Name.Contains("Audit") || field.Name.Contains("ExpenseLedgerPlan") || field.Name.Contains("IsDirty") || field.Name.Contains("Error"))
                        {
                            field.Visibility = Visibility.Collapsed;
                        }

                        if ((field.Name.Contains("SubAllocation") || field.Name.Contains("ParentAllocation")) && !field.Name.Contains("Meta"))
                        {
                            field.Settings.EditorStyle = ExpenseLedgerPlanGrid.Resources["editorStyle"] as Style;
                        }

                        switch (field.Name)
                        {
                            case "LobAllocationKey": field.Label = "Lob Allocation #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ExpenseLedgerPlanKey": field.Label = "Expense Ledger Plan #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "LobAllocation": field.Label = "Lob Allocation";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "LobDescription": field.Label = "Lob Description";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ParentAllocationPct": field.Label = "Parent Allocation";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation1Pct": field.Label = "Sub Allocation 1";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation2Pct": field.Label = "Sub Allocation 2";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation3Pct": field.Label = "Sub Allocation 3";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation4Pct": field.Label = "Sub Allocation 4";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation5Pct": field.Label = "Sub Allocation 5";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation6Pct": field.Label = "Sub Allocation 6";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation7Pct": field.Label = "Sub Allocation 7";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation8Pct": field.Label = "Sub Allocation 8";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "SubAllocation9Pct": field.Label = "Sub Allocation 9";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "AllocationComment": field.Label = "Allocation Comment";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            default: break;
                        }
                    }
                }
                else if (fieldLayout.Description == "ExpenseLedgerPlanSchedLow")
                {
                    foreach (var field in fieldLayout.Fields)
                    {
                        if (!(field.Name == "ExpenseLedgerPlanSchedLowKey"))
                            field.Settings.AllowEdit = true;
                        if (field.Name.Contains("Meta") || field.Name.Contains("Audit") || field.Name.Contains("IsDirty") || field.Name.Contains("Error") || field.Name == "ExpenseLedgerPlan")
                        {
                            field.Visibility = Visibility.Collapsed;
                        }

                        switch (field.Name)
                        {
                            case "ExpenseLedgerPlanSchedLowKey": field.Label = "Expense Ledger Plan Sched Low #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ExpenseLedgerPlanKey": field.Label = "Expense Ledger Plan #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ScheduleTitleKey": field.Label = "Schedule Title #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "ProgramInterestKey": field.Label = "Program Interest #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "PlanResponsibilityKey": field.Label = "Plan Responsibility #";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "PlanResponsibilityManagerKey": field.Label = "Manager";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            case "PlanAddedDate": field.Label = "Plan Added Date";
                                field.Width = Infragistics.Windows.DataPresenter.FieldLength.Auto;
                                break;
                            default: break;
                        }
                    }
                }                
            }
        }

        private void ExpenseLedgerPlanGrid_CellUpdated (object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {
            //ExpenseLedgerPlanGrid.FieldLayouts.FirstOrDefault().Fields            
        }
    }
}
